31.题目描述:求出113的整数中1出现的次数,并算出1001300的整数中1出现的次数?为此他特别数了一下1~13中包含1的数字有1、10、11、12、13因此共出现6次,但是对于后面问题他就没辙了。ACMer希望你们帮帮他,并把问题更加普遍化,可以很快的求出任意非负整数区间中1出现的次数。
import java.util.*;
public class Solution {
public int NumberOf1Between1AndN_Solution(int n) {
if(n <= 0)
return 0;
int high, low, cur, i = 1;
high = n;
int count = 0;
while(high != 0){
high = n / (int)Math.pow(10, i);
int tmp = n % (int)Math.pow(10,i);
cur = tmp / (int)Math.pow(10,i-1);
low = tmp % (int)Math.pow(10,i-1);
if(cur > 1){
count += (high+1) * (int)Math.pow(10, i-1);
}else if(cur == 1){
count += high * (int)Math.pow(10,i-1) + low +1;
}else{
count+= high * (int)Math.pow(10,i-1);
}
i++;
}
return count;
}
}
32.题目描述:输入一个正整数数组,把数组里所有数字拼接起来排成一个数,打印能拼接出的所有数字中最小的一个。例如输入数组{3,32,321},则打印出这三个数字能排成的最小数字为321323。
import java.util.ArrayList;
import java.util.*;
public class Solution {
public String PrintMinNumber(int [] numbers) {
ArrayList<String> list = new ArrayList<>();
for(int i=0; i<numbers.length; i++){
list.add(Integer.toString(numbers[i]));
}
Collections.sort(list,new Comparator<String>(){
public int compare(String o1, String o2){
String s1 = o1 + o2;
String s2 = o2 + o1;
return s1.compareTo(s2);
}
}
);
StringBuilder sb = new StringBuilder();
for(String s : list){
sb.append(s);
}
return sb.toString();
}
}
33.题目描述:把只包含素因子2、3和5的数称作丑数(Ugly Number)。例如6、8都是丑数,但14不是,因为它包含因子7。 习惯上我们把1当做是第一个丑数。求按从小到大的顺序的第N个丑数。
import java.util.*;
public class Solution {
public int GetUglyNumber_Solution(int index) {
if(index <= 0){
return 0;
}
List<Integer> list = new ArrayList();
list.add(1);
int num1, num2, num3;
int index1=0,index2=0,index3=0;
while(list.size() < index){
num1 = list.get(index1) * 2;
num2 = list.get(index2) * 3;
num3 = list.get(index3) * 5;
int min = Math.min(num1, Math.min(num2,num3));
list.add(min);
if(min == num1)
index1 ++;
if(min == num2)
index2 ++;
if(min == num3)
index3 ++;
}
return list.get(index-1);
}
}
34.题目描述:在一个字符串(1<=字符串长度<=10000,全部由字母组成)中找到第一个只出现一次的字符,并返回它的位置。如果字符串为空,返回-1
import java.util.*;
public class Solution {
public int FirstNotRepeatingChar(String str) {
char[] chars = str.toCharArray();//转换成字符数组
LinkedHashMap<Character,Integer> map = new LinkedHashMap<>();
for(int i=0; i<chars.length; i++){
if(map.containsKey(chars[i])){
int value = map.get(chars[i]);
map.put(chars[i],value+1);
}else{
map.put(chars[i],1);
}
}
for(int i=0; i<chars.length; i++){
if(map.get(chars[i]) == 1)
return i;
}
return -1;
}
}
35.题目描述:在数组中的两个数字,如果前面一个数字大于后面的数字,则这两个数字组成一个逆序对。输入一个数组,求出这个数组中的逆序对的总数P。并将P对1000000007取模的结果输出。 即输出P%1000000007
public class Solution {
private int count = 0;
private int[] copy;
public int InversePairs(int [] array) {
if(array == null || array.length == 0)
return 0;
copy = new int[array.length];
sort(array, 0, array.length-1);
return count;
}
public void sort(int[] array, int start, int end){
if(start >= end)
return;
int mid = (start + end) / 2;
sort(array, start, mid);
sort(array,mid+1, end);
merger(array, start, mid, end);
}
public void merger(int[] array, int start, int mid, int end){
int i = start, j = mid+1;
for(int k=i; k <= end; k++){
copy[k] = array[k]; //复制需要合并的数组
}
for(int k = start; k <= end; k++){
if(i > mid) array[k] = copy[j++]; //最半边取尽
else if(j > end) array[k] = copy[i++]; //右半边取尽
else if(copy[i] <= copy[j]) array[k] = copy[i++]; //左边小于等于右边
else {
array[k] = copy[j++];
count = (count + mid - i+1) % 1000000007;
}
}
}
}
36.题目描述:输入两个链表,找出它们的第一个公共结点。
/*
public class ListNode {
int val;
ListNode next = null;
ListNode(int val) {
this.val = val;
}
}*/
public class Solution {
public ListNode FindFirstCommonNode(ListNode pHead1, ListNode pHead2) {
if(pHead1 == null || pHead2 == null)
return null;
int length1 = getLength(pHead1);
int length2 = getLength(pHead2);
int lengthDif = length1 - length2;
ListNode longNode = pHead1;
ListNode shortNode = pHead2;
if(length2 > length1){
lengthDif = length2 - length1;
longNode = pHead2;
shortNode = pHead1;
}
for(int i=0; i<lengthDif; i++){//长链表后移lengthDif位
longNode = longNode.next;
}
while(longNode != null && shortNode != null && longNode != shortNode){
longNode = longNode.next;
shortNode = shortNode.next;
}
return longNode;
}
public int getLength(ListNode head){//获取链表长度
int length = 0;
ListNode pNode = head;
while(pNode != null){
length ++;
pNode = pNode.next;
}
return length;
}
}
37.题目描述:统计一个数字在排序数组中出现的次数。
public class Solution {
public int GetNumberOfK(int [] array , int k) {
if(array == null || array.length == 0)
return 0;
int left = getLeftIndex(array,k);
int right = getRightIndex(array, k);
if(left == -1 || right == -1)
return 0;
return right - left +1;
}
public int getLeftIndex(int[] array, int k){//获取左边第一个k下标
int low = 0, mid = 0, high = array.length-1;
while(low <= high){
mid = (low + high) / 2;
if(array[mid] > k){
high = mid - 1;
}else if(array[mid] < k){
low = mid +1;
}else{
if(mid > 0 && array[mid-1] == k){
high = mid-1;
}else{
return mid;
}
}
}
return -1;
}
public int getRightIndex(int[] array, int k){//获取左边第一个k下标
int low = 0, mid=0, high = array.length-1;
while(low <= high){
mid = (low+high) / 2;
if(array[mid] > k){
high = mid -1;
}else if(array[mid] < k){
low = mid +1;
}else{
if(mid < array.length-1 && array[mid+1] == k){
low = mid+1;
}else{
return mid;
}
}
}
return -1;
}
}
38.题目描述:输入一棵二叉树,求该树的深度。从根结点到叶结点依次经过的结点(含根、叶结点)形成树的一条路径,最长路径的长度为树的深度。
/**
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
public int TreeDepth(TreeNode root) {
if(root == null)
return 0;
int left = TreeDepth(root.left);
int right = TreeDepth(root.right);
return left > right ? (left + 1) : (right + 1);
}
}
39.题目描述:输入一棵二叉树,判断该二叉树是否是平衡二叉树。
public class Solution {
boolean isBalanced = true;
public boolean IsBalanced_Solution(TreeNode root) {
getDeep(root);
return isBalanced;
}
public int getDeep(TreeNode root){
if(root == null)
return 0;
int left = getDeep(root.left);
int right = getDeep(root.right);
if(left - right > 1 || left - right < -1){
isBalanced = false;
}
return left > right ? left + 1 : right + 1;
}
}
40.题目描述:一个整型数组里除了两个数字之外,其他的数字都出现了两次。请写程序找出这两个只出现一次的数字。
//num1,num2分别为长度为1的数组。传出参数
//将num1[0],num2[0]设置为返回结果
public class Solution {
public void FindNumsAppearOnce(int [] array,int num1[] , int num2[]) {
if(array.length == 2){
num1[0] = array[0];
num2[1] = array[1];
}
int result = 0;
for(int i=0; i<array.length; i++){
result ^= array[i];
}
int index = findFirstBitIs1(result);
num1[0] = 0;
num2[0] = 0;
for(int i=0; i<array.length; i++){
if(isBit1(array[i], index)){
num1[0] ^= array[i];
}else{
num2[0] ^= array[i];
}
}
}
public boolean isBit1(int num, int indexBit){
num = num >> indexBit;
return (num & 1) == 1;
}
public int findFirstBitIs1(int num){//求两个出现一次数字的下标
int index = 0;
while((num & 1) == 0){
num = num >> 1;
++index;
}
return index;
}
}
41.题目描述:小明很喜欢数学,有一天他在做数学作业时,要求计算出9~16的和,他马上就写出了正确答案是100。但是他并不满足于此,他在想究竟有多少种连续的正数序列的和为100(至少包括两个数)。没多久,他就得到另一组连续正数和为100的序列:18,19,20,21,22。现在把问题交给你,你能不能也很快的找出所有和为S的连续正数序列? Good Luck!
import java.util.ArrayList;
public class Solution {
public ArrayList<ArrayList<Integer> > FindContinuousSequence(int sum) {
ArrayList<ArrayList<Integer>> list = new ArrayList<>();
if(sum < 3)
return list;
int small = 1;
int big = 2;
int mid = (sum + 1) / 2;
int curSum = big + small;
while(small < mid){
if(curSum == sum){
list.add(countinueSequence(small, big));
curSum -= small;
++ small;
}else if(curSum < sum){
++big;
curSum += big;
}else{
curSum -= small;
++small;
}
}
return list;
}
public ArrayList<Integer> countinueSequence(int small, int big){
ArrayList<Integer> list = new ArrayList<>();
for(int i=small; i<= big; i++){
list.add(i);
}
return list;
}
}
42.题目描述:输入一个递增排序的数组和一个数字S,在数组中查找两个数,使得他们的和正好是S,如果有多对数字的和等于S,输出两个数的乘积最小的。
import java.util.ArrayList;
public class Solution {
public ArrayList<Integer> FindNumbersWithSum(int [] array,int sum) {
int first = 0, last = array.length-1;
int mulSum = Integer.MAX_VALUE;
ArrayList<Integer> list = new ArrayList<>();
while(first < last){
int numFirst = array[first];
int numLast = array[last];
if(numFirst + numLast < sum)
++first;
else if(numFirst + numLast > sum)
--last;
else{
if(numFirst * numLast < mulSum){
mulSum = numFirst * numLast;
list.clear();
list.add(numFirst);
list.add(numLast);
}
++first;
}
}
return list;
}
}
43.题目描述:汇编语言中有一种移位指令叫做循环左移(ROL),现在有个简单的任务,就是用字符串模拟这个指令的运算结果。对于一个给定的字符序列S,请你把其循环左移K位后的序列输出。例如,字符序列S=”abcXYZdef”,要求输出循环左移3位后的结果,即“XYZdefabc”。是不是很简单?OK,搞定它!
public class Solution {
public String LeftRotateString(String str,int n) {
if(str == null || str.length() == 0){
return "";
}
char[] chars = str.toCharArray();
int length = chars.length;
reverse(chars, 0, length-1);
n = n % length;
reverse(chars, 0, length - n -1);
reverse(chars, length -n, length-1);
return new String(chars);
}
public void reverse(char[] chars, int start, int end){//翻转
while(start < end){
char tmp = chars[start];
chars[start] = chars[end];
chars[end] = tmp;
++ start;
--end;
}
}
}
44.题目描述:牛客最近来了一个新员工Fish,每天早晨总是会拿着一本英文杂志,写些句子在本子上。同事Cat对Fish写的内容颇感兴趣,有一天他向Fish借来翻看,但却读不懂它的意思。例如,“student. a am I”。后来才意识到,这家伙原来把句子单词的顺序翻转了,正确的句子应该是“I am a student.”。Cat对一一的翻转这些单词顺序可不在行,你能帮助他么?
public class Solution {
public String ReverseSentence(String str) {
if(str == null || str.length() == 1)
return str;
char[] chars = str.toCharArray();
reverse(chars, 0, str.length()-1);
int start = 0;
for(int i=0; i<chars.length; ++i){
if(chars[i] == ' '){
reverse(chars, start, i-1);
start = i + 1;
}else if(i == chars.length-1){
reverse(chars, start, i);
}
}
return String.valueOf(chars);
}
public void reverse(char[] chars, int start, int end){//翻转
while(start < end){
char tmp = chars[start];
chars[start] = chars[end];
chars[end] = tmp;
++ start;
--end;
}
}
}
45.题目描述:LL今天心情特别好,因为他去买了一副扑克牌,发现里面居然有2个大王,2个小王(一副牌原本是54张_)...他随机从中抽出了5张牌,想测测自己的手气,看看能不能抽到顺子,如果抽到的话,他决定去买体育彩票,嘿嘿!!“红心A,黑桃3,小王,大王,方片5”,“Oh My God!”不是顺子.....LL不高兴了,他想了想,决定大\小 王可以看成任何数字,并且A看作1,J为11,Q为12,K为13。上面的5张牌就可以变成“1,2,3,4,5”(大小王分别看作2和4),“So Lucky!”。LL决定去买体育彩票啦。 现在,要求你使用这幅牌模拟上面的过程,然后告诉我们LL的运气如何。为了方便起见,你可以认为大小王是0。
import java.util.*;
public class Solution {
public boolean isContinuous(int [] numbers) {
if(numbers == null || numbers.length < 1)
return false;
Arrays.sort(numbers);
int numberZero = 0;
int numberGap = 0;
for(int i=0; i<numbers.length && numbers[i] == 0; i++){
++numberZero ;
}
int small = numberZero;
int big = small + 1;
while(big < numbers.length){
if(numbers[small] == numbers[big])//对子
return false;
numberGap += numbers[big] - numbers[small] - 1;
small = big;
++big;
}
if(numberGap <= numberZero)
return true;
return false;
}
}
46.题目描述:每年六一儿童节,牛客都会准备一些小礼物去看望孤儿院的小朋友,今年亦是如此。HF作为牛客的资深元老,自然也准备了一些小游戏。其中,有个游戏是这样的:首先,让小朋友们围成一个大圈。然后,他随机指定一个数m,让编号为0的小朋友开始报数。每次喊到m-1的那个小朋友要出列唱首歌,然后可以在礼品箱中任意的挑选礼物,并且不再回到圈中,从他的下一个小朋友开始,继续0...m-1报数....这样下去....直到剩下最后一个小朋友,可以不用表演,并且拿到牛客名贵的“名侦探柯南”典藏版(名额有限哦!!_)。请你试着想下,哪个小朋友会得到这份礼品呢?(注:小朋友的编号是从0到n-1)
public class Solution {
public int LastRemaining_Solution(int n, int m) {
if(n < 1 || m < 1)
return -1;
int last = 0;
for(int i=2; i<=n; i++){
last = (last + m) % i;
}
return last;
}
}
47.题目描述:求1+2+3+...+n,要求不能使用乘除法、for、while、if、else、switch、case等关键字及条件判断语句(A?B:C)。
public class Solution {
public int Sum_Solution(int n) {
int sum = n;
boolean bool = (sum>0) && (sum += Sum_Solution(n-1))>0;
return sum;
}
}
48.题目描述:写一个函数,求两个整数之和,要求在函数体内不得使用+、-、*、/四则运算符号。
public class Solution {
public int Add(int num1,int num2) {
int sum = num1 ^ num2;
int carry = (num1 & num2) << 1;
sum += carry;
return sum;
}
}
49.题目描述:将一个字符串转换成一个整数,要求不能使用字符串转换整数的库函数。 数值为0或者字符串不是一个合法的数值则返回0
public class Solution {
public int StrToInt(String str) {
if(str == null)
return 0;
boolean negative = false;//判断符号
int result = 0;
int i =0, len = str.length();
if(len > 0){
char firstChar = str.charAt(0);
if(firstChar < '0'){
if(firstChar == '-'){
negative = true;
}else if(firstChar != '+')
return 0;
if(len == 1)
return 0;
i++;
}
while(i < len){
char c = str.charAt(i++);
if(c < '0' || c > '9')
return 0;
if((negative && -result < Integer.MIN_VALUE) || (!negative && result > Integer.MAX_VALUE))
return 0;
result = result * 10 + (c - '0');
}
}else{
return 0;
}
return negative ? -result : result;
}
}
50.题目描述:在一个长度为n的数组里的所有数字都在0到n-1的范围内。 数组中某些数字是重复的,但不知道有几个数字是重复的。也不知道每个数字重复几次。请找出数组中任意一个重复的数字。 例如,如果输入长度为7的数组{2,3,1,0,2,5,3},那么对应的输出是重复的数字2或者3。
public class Solution {
// Parameters:
// numbers: an array of integers
// length: the length of array numbers
// duplication: (Output) the duplicated number in the array number,length of duplication array is 1,so using duplication[0] = ? in implementation;
// Here duplication like pointor in C/C++, duplication[0] equal *duplication in C/C++
// 这里要特别注意~返回任意重复的一个,赋值duplication[0]
// Return value: true if the input is valid, and there are some duplications in the array number
// otherwise false
public boolean duplicate(int numbers[],int length,int [] duplication) {
if(numbers == null || numbers.length < 1)
return false;
for(int i=0; i<numbers.length; ++i){
if(numbers[i] < 0 || numbers[i] > length-1)
return false;
}
for(int i=0; i< length; ++i){
while(numbers[i] != i){
if(numbers[i] == numbers[numbers[i]]){
duplication[0] = numbers[i];
return true;
}
int temp = numbers[i];
numbers[i] = numbers[temp];
numbers[temp] = temp;
}
}
return false;
}
}
51.题目描述:给定一个数组A[0,1,...,n-1],请构建一个数组B[0,1,...,n-1],其中B中的元素B[i]=A[0]A[1]...A[i-1]A[i+1]...A[n-1]。不能使用除法。
import java.util.ArrayList;
public class Solution {
public int[] multiply(int[] A) {
if(A == null || A.length < 1){
return null;
}
int[] array1 = new int[A.length];//保存前半部分矩阵
array1[0] = 1;
for(int i=1; i< A.length; i++){
array1[i] = array1[i-1] * A[i-1];
}
int[] array2 = new int[A.length];
array2[A.length-1] = array1[A.length-1]; // 设置最后一个值
int temp = 1;
for(int i=A.length-2; i>=0; i--){
temp *= A[i+1];
array2[i] = temp * array1[i];
}
return array2;
}
}
52.题目描述:请实现一个函数用来匹配包括'.'和''的正则表达式。模式中的字符'.'表示任意一个字符,而''表示它前面的字符可以出现任意次(包含0次)。 在本题中,匹配是指字符串的所有字符匹配整个模式。例如,字符串"aaa"与模式"a.a"和"abaca"匹配,但是与"aa.a"和"ab*a"均不匹配
public class Solution {
public boolean match(char[] str, char[] pattern) {
if(str == null || pattern == null)
return false;
int strIndex = 0;
int patternIndex = 0;
return isMatchCode(str,pattern,strIndex, patternIndex);
}
/**
当模式中的第二个字符不是“*”时:
1、如果字符串第一个字符和模式中的第一个字符相匹配,那么字符串和模式都后移一个字符,然后匹配剩余的。
2、如果
字符串第一个字符和模式中的第一个字符相不匹配,直接返回false。
而当模式中的第二个字符是“*”时:
如果字符串第一个字符跟模式第一个字符不匹配,则模式后移2个字符,继续匹配。如果字符串第一个字符跟模式第一个字符匹配,可以有3种匹配方式:
1、模式后移2字符,相当于x*被忽略;
2、字符串后移1字符,模式后移2字符;
3、字符串后移1字符,模式不变,即继续匹配字符下一位,因为*可以匹配多位;
*/
public boolean isMatchCode(char[] str, char[] pattern, int strIndex, int patIndex){
if(strIndex == str.length && patIndex == pattern.length)
return true;
if(strIndex != str.length && patIndex == pattern.length)
return false;
if(patIndex+1<pattern.length && pattern[patIndex+1] == '*'){
if(strIndex != str.length &&(pattern[patIndex] ==str[strIndex] || pattern[patIndex] == '.')){
return isMatchCode(str,pattern,strIndex, patIndex+2) || isMatchCode(str,pattern,strIndex+1,patIndex+1)|| isMatchCode(str,pattern, strIndex+1, patIndex);
}else {
return isMatchCode(str, pattern, strIndex, patIndex+2);
}
}
if(strIndex != str.length && (pattern[patIndex] == str[strIndex] || pattern[patIndex] == '.')){
return isMatchCode(str,pattern, strIndex+1, patIndex+1);
}
return false;
}
}
53.题目描述:请实现一个函数用来判断字符串是否表示数值(包括整数和小数)。例如,字符串"+100","5e2","-123","3.1416"和"-1E-16"都表示数值。 但是"12e","1a3.14","1.2.3","+-5"和"12e+4.3"都不是。
public class Solution {
public boolean isNumeric(char[] str) {
String s = String.valueOf(str);
// * 匹配前一个字符0次或多次
// ? 匹配前面的0次或者1次
// . 配除换行符 \n 之外的任何单字符。要匹配 . ,请使用 \.
// + 匹配前面字符1次或多次
return s.matches("[\\+-]?[0-9]*(\\.[0-9]+)?([eE][\\+-]?[0-9]+)?");
}
}
54.题目描述:请实现一个函数用来找出字符流中第一个只出现一次的字符。例如,当从字符流中只读出前两个字符"go"时,第一个只出现一次的字符是"g"。当从该字符流中读出前六个字符“google"时,第一个只出现一次的字符是"l"。
import java.util.*;
public class Solution {
//Insert one char from stringstream
private LinkedHashMap<Character,Integer> map = new LinkedHashMap<>();
public void Insert(char ch)
{
if(map.containsKey(ch)){
int value = map.get(ch);
map.put(ch, value+1);
}else{
map.put(ch, 1);
}
}
//return the first appearence once char in current stringstream
public char FirstAppearingOnce()
{
for(Map.Entry<Character,Integer> entry : map.entrySet()){
if(entry.getValue() == 1)
return entry.getKey();
}
return '#';
}
}
55.题目描述:一个链表中包含环,请找出该链表的环的入口结点。
/*
public class ListNode {
int val;
ListNode next = null;
ListNode(int val) {
this.val = val;
}
}
*/
public class Solution {
public ListNode EntryNodeOfLoop(ListNode pHead)
{
if(pHead == null)
return null;
ListNode p1 = pHead;
ListNode p2 = pHead;
while(p1 != null && p2.next != null){
p1 = p1.next;
p2 = p2.next.next;
if(p1 == p2){
p1 = pHead;
while(p1 != p2){
p1 = p1.next;
p2 = p2.next;
}
return p1;
}
}
return null;
}
}
56.题目描述:在一个排序的链表中,存在重复的结点,请删除该链表中重复的结点,重复的结点不保留,返回链表头指针。 例如,链表1->2->3->3->4->4->5 处理后为 1->2->5
/*
public class ListNode {
int val;
ListNode next = null;
ListNode(int val) {
this.val = val;
}
}
*/
public class Solution {
public static ListNode deleteDuplication(ListNode pHead) {
if(pHead == null)
return null;
ListNode head = new ListNode(-1);
head.next = pHead;
ListNode preNode = head;
ListNode pNode = head.next;
while(pNode != null && pNode.next != null){
if(pNode.val == pNode.next.val){
int value = pNode.val;
while(pNode != null && pNode.val == value)
pNode = pNode.next;
preNode.next = pNode;
}else{
preNode = pNode;
pNode = pNode.next;
}
}
return head.next;
}
}
57.题目描述:给定一个二叉树和其中的一个结点,请找出中序遍历顺序的下一个结点并且返回。注意,树中的结点不仅包含左右子结点,同时包含指向父结点的指针。
/*
public class TreeLinkNode {
int val;
TreeLinkNode left = null;
TreeLinkNode right = null;
TreeLinkNode next = null;
TreeLinkNode(int val) {
this.val = val;
}
}
*/
public class Solution {
public TreeLinkNode GetNext(TreeLinkNode pNode)
{
if(pNode == null)
return null;
if(pNode.right != null){
pNode = pNode.right;
while(pNode.left != null)
pNode = pNode.left;
return pNode;
}else{
TreeLinkNode node = pNode.next;
while(node != null && node.right == pNode){
pNode = node;
node = node.next;
}
return node;
}
}
}
58.题目描述:请实现一个函数,用来判断一颗二叉树是不是对称的。注意,如果一个二叉树同此二叉树的镜像是同样的,定义其为对称的。
/*
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
boolean isSymmetrical(TreeNode pRoot)
{
return isSymmetrical(pRoot, pRoot);
}
boolean isSymmetrical(TreeNode root1, TreeNode root2){
if(root1 == null && root2 == null)
return true;
if(root1 == null || root2 == null)
return false;
if(root1.val != root2.val)
return false;
return isSymmetrical(root1.left,root2.right) && isSymmetrical(root1.right, root2.left);
}
}
59.题目描述:请实现一个函数按照之字形打印二叉树,即第一行按照从左到右的顺序打印,第二层按照从右至左的顺序打印,第三行按照从左到右的顺序打印,其他行以此类推。
import java.util.ArrayList;
import java.util.*;
/*
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
public ArrayList<ArrayList<Integer> > Print(TreeNode pRoot) {
ArrayList<ArrayList<Integer>> list = new ArrayList<>();
if(pRoot == null)
return list;
LinkedList<TreeNode> stack1 = new LinkedList<>();
LinkedList<TreeNode> stack2 = new LinkedList<>();
stack1.push(pRoot);
int index = 1;
while(!stack1.isEmpty() || !stack2.isEmpty()){
ArrayList<Integer> arrayList = new ArrayList<>();
if(index == 1){
while(!stack1.isEmpty()){
TreeNode node = stack1.pop();
if(node.left != null){
stack2.push(node.left);
}
if(node.right != null){
stack2.push(node.right);
}
arrayList.add(node.val);
}
index = 2;
}else{
while(!stack2.isEmpty()){
TreeNode node = stack2.pop();
if(node.right != null){
stack1.push(node.right);
}
if(node.left != null){
stack1.push(node.left);
}
arrayList.add(node.val);
}
index = 1;
}
if(arrayList.size()>0)
list.add(arrayList);
}
return list;
}
}
60.题目描述:从上到下按层打印二叉树,同一层结点从左至右输出。每一层输出一行。
import java.util.ArrayList;
import java.util.*;
/*
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
ArrayList<ArrayList<Integer> > Print(TreeNode pRoot) {
ArrayList<ArrayList<Integer>> list = new ArrayList<>();
if(pRoot == null)
return list;
LinkedList<TreeNode> queue = new LinkedList<>();
queue.offer(pRoot);
while(!queue.isEmpty()){
int num = queue.size();
ArrayList<Integer> array = new ArrayList<>();
while(num > 0){
TreeNode node = queue.poll();
if(node.left != null)
queue.offer(node.left);
if(node.right != null)
queue.offer(node.right);
array.add(node.val);
-- num;
}
if(array.size() > 0){
list.add(array);
}
}
return list;
}
}
61.题目描述:请实现两个函数,分别用来序列化和反序列化二叉树
/*
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
int index = 0;
String Serialize(TreeNode root) {
if(root == null)
return "#,";
String res = root.val +",";
res += Serialize(root.left);
res += Serialize(root.right);
return res;
}
TreeNode Deserialize(String str) {
String[] s = str.split(",");
return Deserialize(s);
}
TreeNode Deserialize(String[] s){
if(s[index].equals("#")){
++index;
return null;
}
TreeNode root = new TreeNode(Integer.parseInt(s[index++]));
root.left = Deserialize(s);
root.right = Deserialize(s);
return root;
}
}
62.题目描述:给定一颗二叉搜索树,请找出其中的第k大的结点。例如, 5 / \ 3 7 /\ /\ 2 4 6 8 中,按结点数值大小顺序第三个结点的值为4。
/*
public class TreeNode {
int val = 0;
TreeNode left = null;
TreeNode right = null;
public TreeNode(int val) {
this.val = val;
}
}
*/
public class Solution {
int index = 0;
TreeNode KthNode(TreeNode pRoot, int k)
{
if(pRoot != null){
TreeNode node = KthNode(pRoot.left,k);//找到中序第一个节点
if(node != null)
return node;
++index;
if(index == k )
return pRoot;
node = KthNode(pRoot.right,k);
if(node != null)
return node;
}
return null;
}
}
63.题目描述:如何得到一个数据流中的中位数?如果从数据流中读出奇数个数值,那么中位数就是所有数值排序之后位于中间的数值。如果从数据流中读出偶数个数值,那么中位数就是所有数值排序之后中间两个数的平均值。
import java.util.*;
public class Solution {
int count = 0;
private PriorityQueue<Integer> minHeap = new PriorityQueue<>();
private PriorityQueue<Integer> maxHeap = new PriorityQueue<>(15,new Comparator<Integer>() {
@Override
public int compare(Integer o1, Integer o2) {
return o2 - o1;
}
});
public void Insert(Integer num) {
if((count & 1) == 0){
if(!maxHeap.isEmpty() && maxHeap.peek() > num) {
maxHeap.offer(num);
num = maxHeap.poll();
}
minHeap.offer(num);
}else {
if(!minHeap.isEmpty() && minHeap.peek() < num){
minHeap.offer(num);
num = minHeap.poll();
}
maxHeap.offer(num);
}
++count;
}
public Double GetMedian() {
if((count & 1) == 1)
return Double.valueOf(minHeap.peek());
else
return Double.valueOf(minHeap.peek() + maxHeap.peek())/ 2;
}
}
64.题目描述:给定一个数组和滑动窗口的大小,找出所有滑动窗口里数值的最大值。例如,如果输入数组{2,3,4,2,6,2,5,1}及滑动窗口的大小3,那么一共存在6个滑动窗口,他们的最大值分别为{4,4,6,6,6,5}; 针对数组{2,3,4,2,6,2,5,1}的滑动窗口有以下6个: {[2,3,4],2,6,2,5,1}, {2,[3,4,2],6,2,5,1}, {2,3,[4,2,6],2,5,1}, {2,3,4,[2,6,2],5,1}, {2,3,4,2,[6,2,5],1}, {2,3,4,2,6,[2,5,1]}。
import java.util.*;
public class Solution {
public static ArrayList<Integer> maxInWindows(int [] num, int size)
{
ArrayList<Integer> list = new ArrayList<>();
if(num == null ||size == 0 || num.length < size)
return list;
LinkedList<Integer> queue = new LinkedList<>();
for(int i=0; i<num.length; i++){
while(!queue.isEmpty()&& num[i] > num[queue.getLast()])
queue.pollLast();
queue.offerLast(i);
if(i - queue.getFirst() >= size)
queue.pollFirst();
if(i >= size-1)
list.add(num[queue.peek()]);
}
return list;
}
}
65.题目描述:请设计一个函数,用来判断在一个矩阵中是否存在一条包含某字符串所有字符的路径。路径可以从矩阵中的任意一个格子开始,每一步可以在矩阵中向左,向右,向上,向下移动一个格子。如果一条路径经过了矩阵中的某一个格子,则该路径不能再进入该格子。 例如[a b c e s f c s a d e e]是3*4矩阵,其包含字符串"bcced"的路径,但是矩阵中不包含“abcb”路径,因为字符串的第一个字符b占据了矩阵中的第一行第二个格子之后,路径不能再次进入该格子。
public class Solution {
public boolean hasPath(char[] matrix, int rows, int cols, char[] str)
{
int[] flag = new int[matrix.length];
for(int i=0; i<rows; i++){
for(int j=0; j<cols; j++){
if(help(matrix,i,j, rows,cols,str,flag,0))
return true;
}
}
return false;
}
public boolean help(char[] matrix, int i, int j, int rows, int cols, char[] str, int[] flag, int k){
int index = i * cols + j;
if(i<0 || i>=rows || j<0 || j >= cols || flag[index] == 1 || str[k] != matrix[index])
return false;
if(k == str.length-1)
return true;
flag[index] = 1;
if(help(matrix,i-1,j,rows,cols,str,flag,k+1) || help(matrix,i+1,j,rows,cols,str,flag,k+1)
|| help(matrix,i,j-1,rows,cols,str,flag,k+1) ||help(matrix,i,j+1,rows,cols,str,flag,k+1))
return true;
flag[index] = 0;
return false;
}
}
66.题目描述:地上有一个m行和n列的方格。一个机器人从坐标0,0的格子开始移动,每一次只能向左,右,上,下四个方向移动一格,但是不能进入行坐标和列坐标的数位之和大于k的格子。 例如,当k为18时,机器人能够进入方格(35,37),因为3+5+3+7 = 18。但是,它不能进入方格(35,38),因为3+5+3+8 = 19。请问该机器人能够达到多少个格子?
public class Solution {
public int movingCount(int threshold, int rows, int cols)
{
int[][] move = new int[rows][cols];
return moveing(threshold, 0, 0, rows, cols, move);
}
public int moveing(int threshold, int i, int j,int rows, int cols, int[][] move){
if(i < 0 || j <0 || i>=rows || j >= cols || !isCanMove(i,j, threshold) || move[i][j] == 1)
return 0;
move[i][j] = 1;
return moveing(threshold, i+1, j, rows, cols, move)
+moveing(threshold, i-1, j, rows, cols, move)+
moveing(threshold, i, j-1, rows, cols, move)+
moveing(threshold, i, j+1, rows, cols, move)+1;
}
public boolean isCanMove(int rows, int cols, int threshold){
int sum = 0;
while(rows > 0){
sum += rows % 10;
rows = rows/ 10;
}
while(cols >0){
sum += cols % 10;
cols = cols /10;
}
if(sum <= threshold)
return true;
return false;
}
}